Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# DisplayRegion Class Reference

A rectangular subregion within a window for rendering into. More...

Inheritance diagram for DisplayRegion:

List of all members.

## Public Member Functions
| clearCullCallback ()
| Removes the callback set by an earlier call to set_cull_callback().
| clearDrawCallback ()
| Removes the callback set by an earlier call to set_draw_callback().
float | getBottom ()
| Retrieves the y coordinate of the bottom edge of the rectangle within its GraphicsOutput.
NodePath | getCamera (Thread current_thread)
| Returns the camera associated with this DisplayRegion, or an empty NodePath if no camera is associated.
NodePath | getCamera ()
| Returns the camera associated with this DisplayRegion, or an empty NodePath if no camera is associated.
int | getCubeMapIndex ()
| Returns the cube map face index associated with this particular DisplayRegion, or -1 if it is not associated with a cube map.
CallbackObject | getCullCallback ()
| Returns the CallbackObject set by set_cull_callback().
CullTraverser | getCullTraverser ()
| Returns the CullTraverser that will be used to draw the contents of this DisplayRegion.
VBase4 | getDimensions ()
| Retrieves the coordinates of the DisplayRegion's rectangle within its GraphicsOutput.
CallbackObject | getDrawCallback ()
| Returns the CallbackObject set by set_draw_callback().
bool | getIncompleteRender ()
| Returns the incomplete_render flag.
float | getLeft ()
| Retrieves the x coordinate of the left edge of the rectangle within its GraphicsOutput.
int | getLensIndex ()
| Returns the specific lens of the associated Camera that will be used for rendering this scene.
GraphicsPipe | getPipe ()
| Returns the GraphicsPipe that this DisplayRegion is ultimately associated with, or NULL if no pipe is associated.
int | getPixelHeight ()
| Returns the height of the DisplayRegion in pixels.
int | getPixelWidth ()
| Returns the width of the DisplayRegion in pixels.
float | getRight ()
| Retrieves the x coordinate of the right edge of the rectangle within its GraphicsOutput.
Texture | getScreenshot ()
| Captures the most-recently rendered image from the framebuffer and returns it as a Texture, or NULL on failure.
bool | getScreenshot (PNMImage image)
| Captures the most-recently rendered image from the framebuffer into the indicated PNMImage.
int | getSort ()
| Returns the sort value associated with the DisplayRegion.
StereoChannel | getStereoChannel ()
| Returns whether the DisplayRegion is specified as the left or right channel of a stereo pair, or whether it is a normal, monocular image.
int | getTextureReloadPriority ()
| Returns the priority which is assigned to asynchronous texture reload requests.
int | getTexViewOffset ()
| Returns the current texture view offset for this DisplayRegion.
float | getTop ()
| Retrieves the y coordinate of the top edge of the rectangle within its GraphicsOutput.
GraphicsOutput | getWindow ()
| Returns the GraphicsOutput that this DisplayRegion is ultimately associated with, or NULL if no window is associated.
bool | isActive ()
| Returns the active flag associated with the DisplayRegion.
bool | isStereo ()
| Returns true if this is a StereoDisplayRegion, false otherwise.
PandaNode | makeCullResultGraph ()
| Returns a special scene graph constructed to represent the results of the last frame's cull operation.
| output (ostream out)
bool | saveScreenshot (Filename const filename)
| Saves a screenshot of the region to the indicated filename.
bool | saveScreenshot (Filename const filename, string image_comment)
| Saves a screenshot of the region to the indicated filename.
Filename | saveScreenshotDefault ()
| Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.
Filename | saveScreenshotDefault (string prefix)
| Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.
| setActive (bool active)
| Sets the active flag associated with the DisplayRegion.
| setCamera (NodePath const camera)
| Sets the camera that is associated with this DisplayRegion.
| setCubeMapIndex (int cube_map_index)
| This is a special parameter that is only used when rendering the faces of a cube map.
| setCullCallback (CallbackObject object)
| Sets the CallbackObject that will be notified when the DisplayRegion is visited during the cull traversal.
| setCullTraverser (CullTraverser trav)
| Specifies the CullTraverser that will be used to draw the contents of this DisplayRegion.
| setDimensions (float l, float r, float b, float t)
| Changes the portion of the framebuffer this DisplayRegion corresponds to.
| setDimensions (VBase4 const dimensions)
| Changes the portion of the framebuffer this DisplayRegion corresponds to.
| setDrawCallback (CallbackObject object)
| Sets the CallbackObject that will be notified when the contents of DisplayRegion is drawn during the draw traversal.
| setIncompleteRender (bool incomplete_render)
| Sets the incomplete_render flag.
| setLensIndex (int index)
| Sets the lens index, allows for multiple lenses to be attached to a camera.
| setSort (int sort)
| Sets the sort value associated with the DisplayRegion.
| setStereoChannel (StereoChannel stereo_channel)
| Specifies whether the DisplayRegion represents the left or right channel of a stereo pair, or whether it is a normal, monocular image.
| setTextureReloadPriority (int texture_reload_priority)
| Specifies an integer priority which is assigned to any asynchronous texture reload requests spawned while processing this DisplayRegion.
| setTexViewOffset (int tex_view_offset)
| Sets the current texture view offset for this DisplayRegion.
## Static Public Member Functions
static TypeHandle | getClassType ()
static Filename | makeScreenshotFilename (string prefix)
| Synthesizes a suitable default filename for passing to save_screenshot().
static Filename | makeScreenshotFilename ()
| Synthesizes a suitable default filename for passing to save_screenshot().

## Detailed Description

A rectangular subregion within a window for rendering into.

Typically, there is one DisplayRegion that covers the whole window, but you may also create smaller DisplayRegions for having different regions within the window that represent different scenes. You may also stack up DisplayRegions like panes of glass, usually for layering 2-d interfaces on top of a 3-d scene.

## Member Function Documentation

clearCullCallback | ( |  | ) |

Removes the callback set by an earlier call to set_cull_callback().

clearDrawCallback | ( |  | ) |

Removes the callback set by an earlier call to set_draw_callback().

float getBottom | ( |  | ) |

Retrieves the y coordinate of the bottom edge of the rectangle within its GraphicsOutput.

This number will be in the range [0..1].

NodePath getCamera | ( | Thread | current_thread | ) |

Returns the camera associated with this DisplayRegion, or an empty NodePath if no camera is associated.

NodePath getCamera | ( |  | ) |

Returns the camera associated with this DisplayRegion, or an empty NodePath if no camera is associated.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from DisplayRegionBase.

Reimplemented in StereoDisplayRegion.

int getCubeMapIndex | ( |  | ) |

Returns the cube map face index associated with this particular DisplayRegion, or -1 if it is not associated with a cube map.

See set_cube_map_index().

CallbackObject getCullCallback | ( |  | ) |

Returns the CallbackObject set by set_cull_callback().

CullTraverser getCullTraverser | ( |  | ) |

Returns the CullTraverser that will be used to draw the contents of this DisplayRegion.

VBase4 getDimensions | ( |  | ) |

Retrieves the coordinates of the DisplayRegion's rectangle within its GraphicsOutput.

These numbers will be in the range [0..1].

CallbackObject getDrawCallback | ( |  | ) |

Returns the CallbackObject set by set_draw_callback().

bool getIncompleteRender | ( |  | ) |

Returns the incomplete_render flag.

See set_incomplete_render().

float getLeft | ( |  | ) |

Retrieves the x coordinate of the left edge of the rectangle within its GraphicsOutput.

This number will be in the range [0..1].

int getLensIndex | ( |  | ) |

Returns the specific lens of the associated Camera that will be used for rendering this scene.

Most Cameras hold only one lens, but for multiple lenses this method may be used to selected between them.

GraphicsPipe getPipe | ( |  | ) |

Returns the GraphicsPipe that this DisplayRegion is ultimately associated with, or NULL if no pipe is associated.

int getPixelHeight | ( |  | ) |

Returns the height of the DisplayRegion in pixels.

int getPixelWidth | ( |  | ) |

Returns the width of the DisplayRegion in pixels.

float getRight | ( |  | ) |

Retrieves the x coordinate of the right edge of the rectangle within its GraphicsOutput.

This number will be in the range [0..1].

Texture getScreenshot | ( |  | ) |

Captures the most-recently rendered image from the framebuffer and returns it as a Texture, or NULL on failure.

bool getScreenshot | ( | PNMImage | image | ) |

Captures the most-recently rendered image from the framebuffer into the indicated PNMImage.

Returns true on success, false on failure.

int getSort | ( |  | ) |

Returns the sort value associated with the DisplayRegion.

StereoChannel getStereoChannel | ( |  | ) |

Returns whether the DisplayRegion is specified as the left or right channel of a stereo pair, or whether it is a normal, monocular image.

See set_stereo_channel().

int getTextureReloadPriority | ( |  | ) |

Returns the priority which is assigned to asynchronous texture reload requests.

See set_texture_reload_priority().

int getTexViewOffset | ( |  | ) |

Returns the current texture view offset for this DisplayRegion.

This is normally set to zero. If nonzero, it is used to select a particular view of any multiview textures that are rendered within this DisplayRegion.

For a StereoDisplayRegion, this is normally 0 for the left eye, and 1 for the right eye, to support stereo textures.

float getTop | ( |  | ) |

Retrieves the y coordinate of the top edge of the rectangle within its GraphicsOutput.

This number will be in the range [0..1].

GraphicsOutput getWindow | ( |  | ) |

Returns the GraphicsOutput that this DisplayRegion is ultimately associated with, or NULL if no window is associated.

bool isActive | ( |  | ) |

Returns the active flag associated with the DisplayRegion.

bool isStereo | ( |  | ) |

Returns true if this is a StereoDisplayRegion, false otherwise.

PandaNode makeCullResultGraph | ( |  | ) |

Returns a special scene graph constructed to represent the results of the last frame's cull operation.

This will be a hierarchy of nodes, one node for each bin, each of which will in term be a parent of a number of GeomNodes, representing the geometry drawn in each bin.

This is useful mainly for high-level debugging and abstraction tools; it should not be mistaken for the low-level cull result itself, which is constructed and maintained internally. No such scene graph is normally constructed during the rendering of a frame; this is an artificial construct created for the purpose of making it easy to analyze the results of the cull operation.

static Filename makeScreenshotFilename | ( |  | ) | `[static]`

Synthesizes a suitable default filename for passing to save_screenshot().

The default filename is generated from the supplied prefix and from the Config variable screenshot-filename, which contains the following strings:

~p - the supplied prefix ~f - the frame count ~e - the value of screenshot-extension All other % strings in strftime().

static Filename makeScreenshotFilename | ( | string | prefix | ) | `[static]`

Synthesizes a suitable default filename for passing to save_screenshot().

The default filename is generated from the supplied prefix and from the Config variable screenshot-filename, which contains the following strings:

~p - the supplied prefix ~f - the frame count ~e - the value of screenshot-extension All other % strings in strftime().

output | ( | ostream | out | ) |

Reimplemented from DisplayRegionBase.

bool saveScreenshot | ( | Filename const | filename,
|  | string | image_comment
| ) |  |

Saves a screenshot of the region to the indicated filename.

Returns true on success, false on failure.

bool saveScreenshot | ( | Filename const | filename | ) |

Saves a screenshot of the region to the indicated filename.

Returns true on success, false on failure.

Filename saveScreenshotDefault | ( | string | prefix | ) |

Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.

The filename is generated by make_screenshot_filename().

Filename saveScreenshotDefault | ( |  | ) |

Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.

The filename is generated by make_screenshot_filename().

setActive | ( | bool | active | ) |

Sets the active flag associated with the DisplayRegion.

If the DisplayRegion is marked inactive, nothing is rendered.

setCamera | ( | NodePath const | camera | ) |

Sets the camera that is associated with this DisplayRegion.

There is a one-to-many association between cameras and DisplayRegions; one camera may be shared by multiple DisplayRegions.

The camera is actually set via a NodePath, which clarifies which instance of the camera (if there happen to be multiple instances) we should use.

setCubeMapIndex | ( | int | cube_map_index | ) |

This is a special parameter that is only used when rendering the faces of a cube map.

Normally you should not need to set it directly. This sets up the DisplayRegion to render to the nth cube map face; the value must be between 0 and 5, inclusive. A normal DisplayRegion that is not associated with any particular cube map should be set to -1.

setCullCallback | ( | CallbackObject | object | ) |

Sets the CallbackObject that will be notified when the DisplayRegion is visited during the cull traversal.

This callback will be made during the cull thread.

The cull traversal is responsible for determining which nodes are visible and within the view frustum, and for accumulating state and transform, and generally building up the list of CullableObjects that are to be eventually passed to the draw traversal for rendering.

At the time the cull traversal callback is made, the traversal for this DisplayRegion has not yet started.

The callback is passed an instance of a DisplayRegionCullCallbackData, which contains pointers to the current scene information, as well as the current DisplayRegion and GSG. The callback replaces* the normal cull behavior, so if your callback does nothing, the scene graph will not be traversed and therefore nothing will be drawn. If you wish the normal cull traversal to be performed for this DisplayRegion, you must call cbdata->upcall() from your callback.

setCullTraverser | ( | CullTraverser | trav | ) |

Specifies the CullTraverser that will be used to draw the contents of this DisplayRegion.

Normally the default CullTraverser is sufficient, but this may be changed to change the default cull behavior.

setDimensions | ( | VBase4 const | dimensions | ) |

Changes the portion of the framebuffer this DisplayRegion corresponds to.

The parameters range from 0 to 1, where 0,0 is the lower left corner and 1,1 is the upper right; (0, 1, 0, 1) represents the whole screen.

setDimensions | ( | float | l,
|  | float | r,
|  | float | b,
|  | float | t
| ) |  |

Changes the portion of the framebuffer this DisplayRegion corresponds to.

The parameters range from 0 to 1, where 0,0 is the lower left corner and 1,1 is the upper right; (0, 1, 0, 1) represents the whole screen.

setDrawCallback | ( | CallbackObject | object | ) |

Sets the CallbackObject that will be notified when the contents of DisplayRegion is drawn during the draw traversal.

This callback will be made during the draw thread.

The draw traversal is responsible for actually issuing the commands to the graphics engine to draw primitives. Its job is to walk through the list of CullableObjects build up by the cull traversal, as quickly as possible, issuing the appropriate commands to draw each one.

At the time the draw traversal callback is made, the graphics state is in the initial state, and no projection matrix or modelview matrix is in effect. begin_scene() has not yet been called, and no objects have yet been drawn. However, the viewport has already been set to the appropriate part of the window, and the clear commands for this DisplayRegion (if any) have been issued.

The callback is passed an instance of a DisplayRegionDrawCallbackData, which contains pointers to the current scene information, as well as the current DisplayRegion and GSG. The callback replaces* the normal draw behavior, so if your callback does nothing, nothing in the DisplayRegion will be drawn. If you wish the draw traversal to continue to draw the contents of this DisplayRegion, you must call cbdata->upcall() from your callback.

setIncompleteRender | ( | bool | incomplete_render | ) |

Sets the incomplete_render flag.

When this is true, the frame will be rendered even if some of the geometry or textures in the scene are not available (e.g. they have been temporarily paged out). When this is false, the frame will be held up while this data is reloaded.

This flag may also be set on the GraphicsStateGuardian. It will be considered true for a given DisplayRegion only if it is true on both the GSG and on the DisplayRegion.

See GraphicsStateGuardian.set_incomplete_render() for more detail.

setLensIndex | ( | int | index | ) |

Sets the lens index, allows for multiple lenses to be attached to a camera.

This is useful for a variety of setups, such as fish eye rendering. The default is 0.

setSort | ( | int | sort | ) |

Sets the sort value associated with the DisplayRegion.

Within a window, DisplayRegions will be rendered in order from the lowest sort value to the highest.

setStereoChannel | ( | StereoChannel | stereo_channel | ) |

Specifies whether the DisplayRegion represents the left or right channel of a stereo pair, or whether it is a normal, monocular image.

This automatically adjusts the lens that is used to render to this DisplayRegion to its left or right eye, according to the lens's stereo properties.

When the DisplayRegion is attached to a stereo window (one for which is_stereo() returns true), this also specifies which physical channel the DisplayRegion renders to.

Normally you would create at least two DisplayRegions for a stereo window, one for each of the left and right channels. The two DisplayRegions may share the same camera (and thus the same lens); this parameter is used to control the exact properties of the lens when it is used to render into this DisplayRegion.

Also see the StereoDisplayRegion, which automates managing a pair of left/right DisplayRegions.

An ordinary DisplayRegion may be set to SC_mono, SC_left, or SC_right. You may set SC_stereo only on a StereoDisplayRegion.

This call also resets tex_view_offset to its default value, which is 0 for the left eye or 1 for the right eye of a stereo display region, or 0 for a mono display region.

setTextureReloadPriority | ( | int | texture_reload_priority | ) |

Specifies an integer priority which is assigned to any asynchronous texture reload requests spawned while processing this DisplayRegion.

This controls which textures are loaded first when multiple textures need to be reloaded at once; it also controls the relative priority between asynchronous texture loads and asynchronous model or animation loads.

Specifying a larger number here makes the textures rendered by this DisplayRegion load up first. This may be particularly useful to do, for instance, for the DisplayRegion that renders the gui.

setTexViewOffset | ( | int | tex_view_offset | ) |

Sets the current texture view offset for this DisplayRegion.

This is normally set to zero. If nonzero, it is used to select a particular view of any multiview textures that are rendered within this DisplayRegion.

For a StereoDisplayRegion, this is normally 0 for the left eye, and 1 for the right eye, to support stereo textures. This is set automatically when you call set_stereo_channel().

All Classes Namespaces Functions Variables Enumerations Enumerator Properties